object Part1 { 

    def compose(f:Int=>Int, g:Int=>Int): Int=>Int = 
        (x:Int) => f(g(x))

    def repeat(f: Int=>Int,  n: Int): Int=>Int = 
        if (n==1) 
            f
        else
            compose(f, repeat(f, n-1))
        

    def main(args: Array[String]) {

        val square = ( x: Int ) => x * x
        val inc = (_: Int ) + 1
        
        val squareinc = compose ( square , inc )
        println(squareinc(6))

        val square4 = repeat (square , 4)
        println(square4(2))
         

    }
}
